;--------------------------------------------------------------------------
; Cviceni 6 z predmetu IAS
;--------------------------------------------------------------------------
;	Sluzby operacniho systemu DOS.
;--------------------------------------------------------------------------
; ZADANI:
;	Dnes jiz vytvorime neco zajimavejsiho. Bude dnes zkoumat funkce
;	DOSu a lehce cuchnete k praci s periferiemi. Vas program by mel ve
;	finale byt schopen vypsat jednoduche menu (coz uz umi ted - udelal
;	jsem to pro vas) a reagovat na prislusne volby (to uz program take
;	umi, ale nic zajimaveho se od nej nedozvite - jen ze to jeste nemate
;	hotove - zkuste si to spustit a pomackejte par klaves...).
;
;	Ukol je jednoduchy. Doplnte prislusne funkce tak, aby konaly
;	nasledujici:
;
;	a) funkce 'PrintDOSVersion' vypise verzi DOSu (sluzba 0x30)
;	b) funkce 'PrintTime' vypise aktualni cas (sluzba 0x2C)
;	c) funkce 'PrintDate' vypise aktualni datum (sluzba 0x2A)
;	d) funkce 'PrintPath' vypise aktualni cestu (sluzby 0x19 a sluzba 0x47)
;
;	Tyto funkce vypisi udaje na obrazovku tak, jak je popsano v sekci "VYSTUPEM
;	BY MELY BYT NASLEDUJICI UDAJE:". K vypisu udaju vyuzijte funkce knihovny
;	"rw.asm". Nektere retezce jiz mate nachystane v datovem segmentu. Staci se
;	jen dobre podivat. At pak nemusite psat vse sami (zbytecne). Ale pozor!
;	Nektere promenne (rezervace mista v pameti) budete muset doplnit sami!
;
; Nektere funkce z knihovny "rw.asm":
;
;	Funkce Write_Byte vypise dekadicky bez znamenka hodnotu ulozenou v AL (0 - 255).
;	Funkce Write_ShortInt vypise dekadicky se znamenkem hodnotu ulozenou v AL (-128 - 127).
;	Funkce Write_Word vypise dekadicky bez znamenka hodnotu ulozenou v AX (0 - 65535).
;	Funkce Write_Integer vypise dekadicky se znamenkem hodnotu ulozenou v AX (-32768 - 32767).
;
; Seznam vstupu a vystupu vsech potrebnych sluzeb DOSu (preruseni INT 0x21) mate zde:
;
;  Funkce 0x30 (48) - Zjisteni verze MS DOSu
;	Vstup:
;		AH = 0x30
;	Vystup:
;		AL = hlavni cislo verze (napr. 4)
;		AH = vedlejsi cislo verze (napr. 20)
;		BX = 0
;		CX = 0
;	Poznamka:
;		Mame-li verzi DOSu 4.20, bude AL=4 a AH=20... je to jasne?
;
;  Funkce 0x2A (42) - Zjisteni aktualniho data
;	Vstup:
;		AH = 0x2A
;	Vystup:
;		AL = den (0=nedele, 1=pondeli, ..., 6=sobota)
;		CX = rok (1980 - 2099)
;		DH = mesic (1 - 12)
;		DL = den (1 - 31)
;
;  Funkce 0x2C (44) - Zjisteni aktualniho casu
;	Vstup:
;		AH = 0x2C
;	Vystup:
;		CH = hodina (0 - 23)
;		CL = minuta (0 - 59)
;		DH = sekunda (0 - 59)
;		DL = setina sekundy (0 - 99)
;
;  Funkce 0x19 (25) - Zjisteni aktualniho disku
;	Vstup:
;		AH = 0x19
;	Vystup:
;		AL = cislo disku (0 = 'A', 1 = 'B', ...)
;
;  Funkce 0x47 (71) - Zjisteni aktualniho adresare
;	Vstup:
;		AH = 0x47
;		DS:SI = adresa mista, kam bude ulozen nazev aktualniho adresare
;			na danem miste musi byt rezervovano alespon 64 bytu, na
;			tomto miste bude ulozena cesta bez disku (tj. napr misto
;			'C:\cosi\xy' zde bude jen 'cosi\xy') !!!! Tento retezec
;			neni ukoncen znakem '$', jak jste zvykli, ale cislem 0
;			(nikoliv znakem '0' - ten ma hodnotu 48, ale hodnotou 0). 
;		DL = cislo disku (0 = aktualni disk, 1 = 'A', 2 = 'B' ...),
;		     sem date bud 0 nebo vysledek sluzby 0x19 zvyseny o 1
;	Vystup:
;		AX = chybovy kod (je-li CF = 1)
;

; HODNOCENI:
;	1 bod za realizaci bodu a,b
;	1 bod za realizaci bodu c,d
;
; KONTROLNI HODNOTY:
; VYSTUPEM BY MELY BYT NASLEDUJICI UDAJE (napriklad, zalezi na datu, case, verzi DOSu ...!!!):
;
;	bod a) po stisknuti klavesy '1' napise:	Verze DOSu: 5.0 (podle verze systemu)
;	bod b) po stisknuti klavesy '3' napise:	Aktualni cas je 11:46:23.56 (podle aktualniho casu)
;	bod c) po stisknuti klavesy '2' napise:	Dnes je Nedele, 21.12.2010 (podle aktualniho data)
;	bod d) po stisknuti klavesy '4' napise:	Aktualni adresar je P:\IAS (podle aktualniho adresare!)
;
;--------------------------------------------------------------------------

	bits 16
	%include "rw.asm"

	segment code
;--------------------------------------------------------------------------
PrintDOSVersion:
	pusha

	mov dx,_msg_dos_version	; toto mi prozradi, ze to jeste nemate...
	call Print_Str

;  Funkce 0x30 (48) - Zjisteni verze MS DOSu
;	Vstup:
;		AH = 0x30
;	Vystup:
;		AL = hlavni cislo verze (napr. 4)
;		AH = vedlejsi cislo verze (napr. 20)
;		BX = 0
;		CX = 0
;	Poznamka:
;		Mame-li verzi DOSu 4.20, bude AL=4 a AH=20... je to jasne?

; j.i

mov ah, 0x30
int 0x21
mov bl, ah
xor ah, ah

pusha
call Write_Word
popa

pusha
mov al, '.'
call Write_Char
popa

mov al, bl
xor ah, ah

pusha
call Write_Word
popa
	popa
	ret
;--------------------------------------------------------------------------

Write_MyWord:
pusha

	; v al je cas
cmp al, 10
jae @nad_deset

pusha
mov al, '0'
call Write_Char
popa

@nad_deset:

call Write_Word

popa
ret


PrintTime:
	pusha

	mov dx,_msg_time	; toto mi prozradi, ze to jeste nemate...
	call Print_Str

;  Funkce 0x2C (44) - Zjisteni aktualniho casu
;	Vstup:
;		AH = 0x2C
;	Vystup:
;		CH = hodina (0 - 23)
;		CL = minuta (0 - 59)
;		DH = sekunda (0 - 59)
;		DL = setina sekundy (0 - 99)

; hh:mm:ss.tt

mov ah, 0x2c
int 0x21
xor ah, ah

mov al, ch
pusha
call Write_MyWord
popa

pusha
mov al, ':'
call Write_Char
popa
; hodiny

mov al, cl
pusha
call Write_MyWord
popa

pusha
mov al, ':'
call Write_Char
popa
; minuty

mov al, dh
pusha
call Write_MyWord
popa

pusha
mov al, '.'
call Write_Char
popa
; sekundy

mov al, dl
pusha
call Write_MyWord
popa
; setiny

	popa
	ret
;--------------------------------------------------------------------------
PrintDate:
	pusha

	mov dx,_msg_date	; toto mi prozradi, ze to jeste nemate...
	call Print_Str

;  Funkce 0x2A (42) - Zjisteni aktualniho data
;	Vstup:
;		AH = 0x2A
;	Vystup:
;		AL = den (0=nedele, 1=pondeli, ..., 6=sobota)
;		CX = rok (1980 - 2099)
;		DH = mesic (1 - 12)
;		DL = den (1 - 31)

;	bod c) po stisknuti klavesy '2' napise:	Dnes je Nedele, 21.12.2010 (podle aktualniho data)

mov ah, 0x2a
int 0x21

pusha
mov bx, _msg_weekday
xor ah, ah
add bx, ax
add bx, ax; je to word!
mov dx, [bx]
call Print_Str
popa
; den v tdnu (jmno :o)))

xor ax, ax

pusha
mov al, dl
call Write_Word
popa
pusha
mov al, '.'
call Write_Char
popa
; den

pusha
mov al, dh
call Write_Word
popa
pusha
mov al, '.'
call Write_Char
popa
; mesic

pusha
mov ax, cx
call Write_Word
popa
; rok

	popa
	ret
;--------------------------------------------------------------------------
PrintPath:
	pusha

	mov dx,_msg_path	; toto mi prozradi, ze to jeste nemate...
	call Print_Str

;  Funkce 0x19 (25) - Zjisteni aktualniho disku
;	Vstup:
;		AH = 0x19
;	Vystup:
;		AL = cislo disku (0 = 'A', 1 = 'B', ...)

mov ah, 0x19
int 0x21

pusha
add al, 'A'
call Write_Char
mov al, ':'
call Write_Char
mov al, '\'
call Write_Char
popa

;
;  Funkce 0x47 (71) - Zjisteni aktualniho adresare
;	Vstup:
;		AH = 0x47
;		DS:SI = adresa mista, kam bude ulozen nazev aktualniho adresare
;			na danem miste musi byt rezervovano alespon 64 bytu, na
;			tomto miste bude ulozena cesta bez disku (tj. napr misto
;			'C:\cosi\xy' zde bude jen 'cosi\xy') !!!! Tento retezec
;			neni ukoncen znakem '$', jak jste zvykli, ale cislem 0
;			(nikoliv znakem '0' - ten ma hodnotu 48, ale hodnotou 0). 
;		DL = cislo disku (0 = aktualni disk, 1 = 'A', 2 = 'B' ...),
;		     sem date bud 0 nebo vysledek sluzby 0x19 zvyseny o 1
;	Vystup:
;		AX = chybovy kod (je-li CF = 1)

; c:/fdhs/fdh

mov si, p_s_mujstring
mov dl, 0
mov ah, 0x47
int 0x21

jnc @no_fail

call WriteLn
call WriteLn
pusha
mov dx, _msg_err_cwd
call Write_String
popa
call Write_Word
call WriteLn		; vypisuje chybovou hlasku ...

@no_fail:


mov dx, p_s_mujstring

pusha
mov bx, dx
@my_loop:
mov al, [ds:bx]
pusha
call Write_Char
popa
inc bx
cmp al, 0
jne @my_loop
popa
; vymeni nulu za dolar

	popa
	ret
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
; Pomocne funkce - tyto funkce nechte byt...	
;--------------------------------------------------------------------------
ClearScreen:
;
;	Funkce vymaze obrazovku. Nic nemente, pokud nevite, co delate...
;
; Vstup:
;		nic
; Vystup:
;		Vymazana obrazovka

	pusha		; Budme slusni ...

	xor cx,cx		; zacneme od radku 0 a sloupce 0
	mov bx,0x0700	; nastavime sedou barvu pisma a cerne pozadi
	mov dh,24		; chceme vymazat 25 radku
	mov dl,79		; a 80 sloupcu
	mov ax,0x0600	; pouzijeme sluzbu 0x06
	int 0x10		; preruseni 0x10

	popa
	ret
;--------------------------------------------------------------------------
PrintInvalidChoice:
;
;	Funkce pro pripad vyberu neplatne volby.
;

	mov dx,_msg_newAttempt
	call Print_Str
	
	ret
;--------------------------------------------------------------------------
PrintMenu:
;
;	Funkce vypise menu na obrazovku. Tuto funkci zatim nemente.
;
; Vstup:
;		nic
; Vystup:
;		Vypise menu.

	pusha			; jsme slusni, proto schovame registry

	xor bx,bx		; premistime kurzor na pozici 0,0
	xor dx,dx		; pouzijeme k tomu sluzbu 0x02 preruseni 0x10
	mov ax,0x0200
	int 0x10

	mov si,_cases			; zacneme od prvni polozky
	mov cx,[_cases_count]	; do CX pocet moznosti
	
.for_begin:

	mov al,[si + sCase.char]; do AL dame znak, ktery odpovida dane volbe
	mov [_msg_sep3 + 1],al	; ulozime ho do retezce pro vypis (mezi '')
	mov dx,_msg_sep3		; a vypiseme "'x' "
	call Print_Str

	mov dx,[si + sCase.text]; vypiseme popisek volby (napr. "Konec programu")
	call Print_Str
	call WriteLn

	add si,sCase_size		; posuneme se v poli o tolik bytu, kolik jich
	loop .for_begin			; zabira jedna volba a opakujeme pro vsechny

	popa			; vratime puvodni stav registru
	ret

;--------------------------------------------------------------------------
GetChar:
;
;	Funkce ceka na stisk klavesy. Taky zatim nemenit.
;
; Vstup:
;		nic
; Vystup:
;		AL = hodnota stiskle klavesy
;
	xor ah,ah		; cekame na znak z klavesnice
	int 0x16		; vysledek - znak je v AL

	ret
;--------------------------------------------------------------------------
Exit:
;
;	Funkce ukonci beh programu. Tady taky nic nezkousejte.
;
; Vstup:
;		nic
; Vystup:
;		Funkce ukonci beh programu.

	mov dx,_msg_exit; vypiseme rozlouceni
	call Print_Str

	epilogue		; ukoncime program
;--------------------------------------------------------------------------
PrintLastChoice:
;
;	Funkce vypise posledni zvolenou volbu.
;
; Vstup:
;		SI - ukazuje na vybranou volbu
; Vystup:
;		Vypis na obrazovku + zavolani funkce.

	call WriteLn		; vypiseme volny radek (aby to bylo hezci)
	
	mov [_msg_sep3 + 1],al	; znak stisknute klavesy ulozime do retezce
	mov dx,_msg_ch_detail	; a vypiseme ve tvaru Zvolili jste: 'x' "
	call Print_Str

	mov dx,[si + sCase.text]; vypiseme nazev volby
	call Print_Str
	call WriteLn
	call WriteLn

	call word [si + sCase.function] ; na adrese SI + sCase.function je adresa funkce, kterou mame
	call WriteLn		; volat a pro jistotu jeste vypiseme volny radek
	
	ret	
;--------------------------------------------------------------------------
;
; Hlavni cast programu.
; V teto casti nic nemente (muzete, ale az bude funkcnost predvedena cvicicimu)!!!!
; Doplnte kod jednotlivych fuknci uvedenych vyse.
;
..start:

	prologue

	call ClearScreen	; vycistime obrazovku
	call PrintMenu		; vypiseme menu
	call GetChar		; cekame na stisk klavesy
	jmp .first_time		; jedeme poprve => preskocime vypis 'PrintLastChoice'

.begin:

	call ClearScreen	; vycistime obrazovku
	call PrintMenu		; vypiseme menu
	call PrintLastChoice; vypiseme posledni volbu
	call GetChar		; cekame na stisk klavesy
	
.first_time:

	mov si,_cases			; zpracujeme jednotlive moznosti, zacneme od prvni volby
	mov cx,[_cases_count]	; do CX dame pocet moznosti
	
.next_case:

	cmp al,[si + sCase.char]; porovname stisknutou klavesu se znakem moznosti
	jz .begin				; je-li to ta prava, skocime na zacatek (SI bude ukazovat na
							; zvolenou volbu
	add si,sCase_size		; posuneme se v poli voleb o tolik bytu, kolik
	loop .next_case			; zabira jedna volba

	mov [si + sCase.char],al; neznama volba => hodnotu klavesy ulozime do volby (pro vypis)	
	jmp .begin				; a jdeme na zacatek

;--------------------------------------------------------------------------
	segment data
;
; Tady mate nachystano velke mnozstvi ruznych textu.
; Meli byste jich vyuzit... usnadni vam to praci. :-)
;

%define EOS '$'
%define EOL 0x0D, 0x0A
%define EOLS 0x0D, 0x0A, EOS

_msg_not_done	db	"Tuto $funkci jeste nemam hotovou.",EOL
				db	"Hrozne se za to stydim.",EOL
				db	"Odpustte mi to, prosim, pane asistente.",EOLS
_msg_menu		db	"Zvolte jeden z prikazu (stisknete prislusnou klavesu):",EOL
_msg_invalid	db	"- neplatna volba",EOS
_msg_newAttempt	db	"Tato moznost v menu neni! Zkuste to znovu.",EOLS
_msg_exit		db	"Ahoj!",EOLS
_msg_dos_version	db	"Verze DOSu je ",EOS
_msg_date		db	"Dnes je ",EOS
_msg_time		db	"Aktualni cas je ",EOS
_msg_path		db	"Aktualni adresar je ",EOS
_msg_mem		db	"Celkova velikost systemove pameti je ",EOS
_msg_suf_kB		db	" kB",EOLS
_msg_vga_mode	db	"Aktualni graficky rezim: ",EOS
_msg_vga_cols	db	", pocet sloupcu je: ",EOS
_msg_sep1		db	", ",EOS
_msg_sep2		db	":\",EOS
_msg_ch_detail	db	"Zvolili jste: "
_msg_sep3		db	"' ' ",EOS

_msg_err_cwd	db	"Neco se po***o ",EOS

_msg_sat		db	"Nedele ",EOS
_msg_mon		db	"Pondeli ",EOS
_msg_tue		db	"Utery ",EOS
_msg_wed		db	"Streda ",EOS
_msg_thu		db	"Ctwrteg ",EOS
_msg_fri		db	"Patek ",EOS
_msg_sun		db	"Sobota ",EOS
_msg_week
_msg_weekday	dw	_msg_sat, _msg_mon, _msg_tue, _msg_wed, _msg_thu, _msg_fri, _msg_sun 

_mi_dos_version	db	"Vypsat verzi DOSu",EOS
_mi_date		db	"Vypsat datum",EOS
_mi_time		db	"Vypsat cas",EOS
_mi_path		db	"Vypsat aktualni adresar",EOS
_mi_exit		db	"Konec programu",EOS

;p_s_mujstring	resb 65
p_s_mujstring	db	"Test zakonceni nulou ->",0

struc sCase
	.char		resb 1
	.text		resw 1
	.function	resw 1
endstruc

_cases_count	dw	5
_cases:
		istruc sCase
			at sCase.char, 		db '1'
			at sCase.text, 		dw _mi_dos_version
			at sCase.function,	dw PrintDOSVersion
		iend
		istruc sCase
			at sCase.char,		db '2'
			at sCase.text,		dw _mi_time
			at sCase.function, 	dw PrintTime
		iend
		istruc sCase
			at sCase.char,		db '3'
			at sCase.text,		dw _mi_date
			at sCase.function, 	dw PrintDate
		iend
		istruc sCase
			at sCase.char,		db '4'
			at sCase.text,		dw _mi_path
			at sCase.function, 	dw PrintPath
		iend
		istruc sCase
			at sCase.char,		db 'q'
			at sCase.text,		dw _mi_exit
			at sCase.function, 	dw Exit
		iend
		istruc sCase
			at sCase.char,		db 0
			at sCase.text,		dw _msg_invalid
			at sCase.function, 	dw PrintInvalidChoice
		iend